Subject: Re: [xdp-hints] Re: [RFC bpf-next v2 09/24] xdp: Add VLAN tag hint

From: Jakub Kicinski <[email-masked]>
Date: Thu, 5 Oct 2023 11:06:35 -0700

On Thu, 5 Oct 2023 11:20:49 -0600 David Ahern wrote:
> > Every time I'm involved in conversations about NIC datapath host
> > interfaces I cringe at this stupid VLAN offload. Maybe I'm too
> > daft to understand it's amazing value but we just shift 2B from
> > the packet to the descriptor and then we have to worry about all
> > the corner cases that come from vlan stacking :(  
> 
> 4B (vlan tci + protocol).
> 
> VLAN stripping in S/W and pushing the header on Tx is measurable and
> does have a noticeable performance impact.
> 
> XDP programs need to co-exist with enabled offloads. If the tag is not
> stripped, XDP program needs to handle it. If the tag is stripped, the
> XDP program needs to access to the value.

Well, I thought I'd ask :) I'm not opposed.

But if either of you have the data on how much slower well-implemented
Rx stripping in the driver is than putting the info in the descriptor,
I'd be very interested.

Tx is a different situation.